﻿/*
Lith DirectX Wrapper - Main Class
20 July 2008
*/

#include <windows.h>
#include <d3d9.h>
#pragma hdrstop

#include "tlib.h"

#include "Util.h"

#include "CDX.h"
#include "CDevice.h"

using namespace tlib;
using namespace LithDX;



CDX::CDX()
{
	mDirect3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (mDirect3D == NULL)
		throw TException(L"Direct3DCreate9() failed");
}



CDX::~CDX()
{
	mDirect3D->Release();
}



CDevice* CDX::CreateDevice(EDisplayMode aDisplayMode, HWND aFocusWindow, int aXRes, int aYRes)
{
	D3DPRESENT_PARAMETERS PresentParam;
	ZeroMemory(&PresentParam, sizeof(D3DPRESENT_PARAMETERS));
	PresentParam.BackBufferFormat = D3DFMT_X8R8G8B8;
	PresentParam.BackBufferCount = 1;
	PresentParam.MultiSampleType = D3DMULTISAMPLE_NONE;
	PresentParam.SwapEffect = D3DSWAPEFFECT_DISCARD;
	PresentParam.EnableAutoDepthStencil = true;
	PresentParam.AutoDepthStencilFormat = D3DFMT_D16;
	PresentParam.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER | D3DPRESENTFLAG_DISCARD_DEPTHSTENCIL | D3DPRESENTFLAG_VIDEO;
	PresentParam.PresentationInterval = D3DPRESENT_INTERVAL_DEFAULT;
	if (aDisplayMode == dmWindow)
	{
		PresentParam.Windowed = true;
	}
	else
	{
		PresentParam.BackBufferWidth = aXRes;
		PresentParam.BackBufferHeight = aYRes;
		PresentParam.Windowed = false;
		PresentParam.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT;
	}
	IDirect3DDevice9 *Device;
	CheckHResult(mDirect3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, aFocusWindow,
			D3DCREATE_HARDWARE_VERTEXPROCESSING, &PresentParam, &Device));
	return new CDevice(Device);
}