﻿/*
Lith GUI Library - Main Class
*/

namespace LithGUI
{

class CForm;
class IThread;

class IMessageHandler
{
public:
	virtual bool Message(UINT aMessage, WPARAM aWParam, LPARAM aLParam, LRESULT& aResult) = 0;
};

class CGUI
{
public:
	CGUI(HINSTANCE aInstance);
	~CGUI();

	CForm* CreateForm(IMessageHandler* aMessageHandler, tlib::TString aCaption, int aXSize,
			int aYSize);

	void CreateThread(IThread* aThread);

	HINSTANCE GetInstance() { return mInstance; }

private:
	HINSTANCE mInstance;

	static LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
	bool HandleMessage(CForm* aForm, UINT aMessage, WPARAM aWParam, LPARAM aLParam, LRESULT&);

	int mNumClasses;
	tlib::TStringMap<IMessageHandler*> mClassMessageHandler;

	tlib::TArray<CForm*> mFormList;

	static DWORD WINAPI RunThread(LPVOID lpParameter);
	tlib::TArray<HANDLE> mThreads;
};

}