﻿class CPreLoader;
class CTitleScreen;
class CGameController;

class CApplication : public IStuff
{
public:
	CApplication(HINSTANCE aInstance);
	~CApplication();

	void Run();

	void OnDestroy();
	void OnTimer();
	void OnKeyDown(int aKey);
	void OnKeyUp(int aKey);
	void OnChar(int aChar);
	void OnMouseMove(int aX, int aY);
	void OnMouse(bool aRight, bool aUp, int aX, int aY);
	void OnUser(int aMessage, WPARAM aWParam, LPARAM aLParam);

	LithDX::CTexture* GetTexture(tlib::TString aTextureName);
	LithDX::CSprite* GetSprite(tlib::TString aSpriteName);
	INT_PTR GetSound(tlib::TString aSoundName);

	double Random();
	int Random(int aStart, int aEnd);

	void PreLoadInfo(int aInfo);

	void PlaySound(INT_PTR aSound);

	void DrawNumber(int aNumber, int aX, int aY);

	void GameOver(int aFrogsSaved, int aFrogsSplatted);

	bool GetHighscore(int& aFrogsSaved, int& aFrogsSplatted);

private:
	LithGUI::CGUI *mGUI;
	LithDX::CDX *mDX;
	void Initialise();
	LithGUI::CForm *mMainForm;
	LithDX::CDevice *mDevice;
	tlib::TStringMap<LithDX::CTexture*> mTextures;
	tlib::TStringMap<LithDX::CSprite*> mSprites;
	tlib::TStringMap<INT_PTR> mSounds;

	CPreLoader *mPreLoader;
	CTitleScreen *mTitleScreen;
	CGameController *mGameController;

	LithDX::CSprite *mDigits[10];

	bool mHasHighscore;
	int mFrogsSavedHigh;
	int mFrogsSplattedHigh;

	bool mGameOver;
};