﻿/*
Frog Rescue - Frog class
*/

#include <windows.h>
#include <math.h>
#pragma hdrstop

#include "tlib.h"

#include "CFrog.h"

using namespace tlib;



CFrog::CFrog(double aX, double aY, double aZ, double aAngle)
{
	mX = aX;
	mY = aY;
	mZ = aZ;
	mAngle = aAngle;

	mState = fsIdle;
}



void CFrog::Jump(int aDistance, int aWaitTime)
{
	if (mState == fsJumping)
		throw TException(L"Already jumping");
	mState = fsJumping;
	mJumpDistance = aDistance;
	mWaitTime = aWaitTime;
	mStep = 0;
}



void CFrog::Update()
{
	switch (mState)
	{
	case fsJumping:
		mStep++;
		mZ = (double)(mStep * (mJumpDistance - mStep)) * 0.1;
		mX += cos(mAngle) / 3;
		mY += sin(mAngle) / 3;
		if (mStep == mJumpDistance)
		{
			mState = mWaitTime == 0 ? fsIdle : fsWaiting;
			mStep = 0;
		}
		break;
	case fsWaiting:
		mStep++;
		if (mStep == mWaitTime)
			mState = fsIdle;
		break;
	}
}