﻿/*
Main form class
*/

#include <windows.h>
#include <d3d9.h>
#pragma hdrstop

#include "tlib.h"
#include "LithGUI.h"
#include "LithDX.h"
#include "LithUtil.h"

#include "IStuff.h"

#include "CApplication.h"
#include "CMainFormHandler.h"

using namespace tlib;
using namespace LithGUI;



CMainFormHandler::CMainFormHandler(CApplication* aApplication)
{
	mApplication = aApplication;
}



bool CMainFormHandler::Message(UINT aMessage, WPARAM aWParam, LPARAM aLParam, LRESULT& aResult)
{
	switch (aMessage)
	{
	case WM_DESTROY:
		mApplication->OnDestroy();
		aResult = 0;
		return true;
	case WM_TIMER:
		mApplication->OnTimer();
		aResult = 0;
		return true;
	case WM_KEYDOWN:
		mApplication->OnKeyDown(aWParam);
		aResult = 0;
		return true;
	case WM_KEYUP:
		mApplication->OnKeyUp(aWParam);
		aResult = 0;
		return true;
	case WM_CHAR:
		mApplication->OnChar(aWParam);
		aResult = 0;
		return true;
	case WM_MOUSEMOVE:
		mApplication->OnMouseMove(LOWORD(aLParam), HIWORD(aLParam));
		aResult = 0;
		return true;
	case WM_LBUTTONDOWN:
		mApplication->OnMouse(false, false, LOWORD(aLParam), HIWORD(aLParam));
		aResult = 0;
		return true;
	case WM_LBUTTONUP:
		mApplication->OnMouse(false, true, LOWORD(aLParam), HIWORD(aLParam));
		aResult = 0;
		return true;
	case WM_RBUTTONDOWN:
		mApplication->OnMouse(true, false, LOWORD(aLParam), HIWORD(aLParam));
		aResult = 0;
		return true;
	case WM_RBUTTONUP:
		mApplication->OnMouse(true, true, LOWORD(aLParam), HIWORD(aLParam));
		aResult = 0;
		return true;
	default:
		if (aMessage >= WM_USER && aMessage <= 0x7FFF)
			mApplication->OnUser(aMessage - WM_USER, aWParam, aLParam);
		return false;
	}
}