﻿/*
Frog Rescue - Title screen class
*/

#include <windows.h>
#include <d3d9.h>
#pragma hdrstop

#include "tlib.h"
#include "LithGUI.h"
#include "LithDX.h"
#include "LithUtil.h"

#include "IStuff.h"

#include "CApplication.h"
#include "CTitleScreen.h"

using namespace tlib;
using namespace LithDX;



CTitleScreen::CTitleScreen(CApplication* aOwner)
{
	mOwner = aOwner;
	mTitle = mOwner->GetSprite(SL("Title"));

	mFrogSavedSprite = mOwner->GetSprite(SL("FrogSaved"));
	mFrogSplattedSprite = mOwner->GetSprite(SL("FrogSplatted"));
}



void CTitleScreen::Update()
{
}



void CTitleScreen::Render(CDevice* aDevice)
{
	aDevice->SetTransform(D3DTS_PROJECTION, CMatrix::Identity());
	aDevice->SetTransform(D3DTS_VIEW, CMatrix::Identity());
	aDevice->SetTransform(D3DTS_WORLD, CMatrix::Identity());

	aDevice->DrawSprite(mTitle, 512, 384, 0.5, 0.5);

	int FrogsSaved;
	int FrogsSplatted;
	if (mOwner->GetHighscore(FrogsSaved, FrogsSplatted))
	{
		aDevice->DrawSprite(mFrogSavedSprite, 200, 600, 0, 0);
		mOwner->DrawNumber(FrogsSaved, 250, 604);
		aDevice->DrawSprite(mFrogSplattedSprite, 600, 600, 0, 0);
		mOwner->DrawNumber(FrogsSplatted, 650, 604);
	}
}