namespace tlib
{

template <typename A, typename T> class CStackIndex
{
public:
	CStackIndex() { }

	void Push(T item)
	{
		FArray.Add(item);
	}

	void Pop()
	{
		if (!FArray.get(NumItems))
			throw TException(L"Stack empty");
		FArray.Remove(FArray.get(NumItems) - 1);
	}

	PROPERTY_F(Top, T&)

	PROPERTY_F(Empty, bool)

private:
	A FArray;

	T& _GetTop() const
	{
		if (!FArray.get(NumItems))
			throw TException(L"Stack empty");
		return FArray.get(Last);
	}

	bool _GetEmpty() const
	{
		return FArray.get(NumItems) == 0;
	}
};

template <typename T> class TStack : public CStackIndex<CArrayIndex<T>, T> { };
template <typename T> class TFastStack : public CStackIndex<CFastArrayIndex<T>, T> { };

}   // namespace tlib